//==============================================================================
// key.c L[͂𓾂
//==============================================================================
#include <key.h>

KEY_STATUS key;
u16 key_array[ 4 + 6 ] IN_EWRAM;

//--------------------------------------------------------------
// L[`FbN
void KeyCheck()
{
	u16 cnt_temp = REG_P1;			// REG_P1
	u16 cnt = 0;

	if (cnt_temp & key_array[BUTTON_A]) cnt += KEY_ABUTTON;
	if (cnt_temp & key_array[BUTTON_B]) cnt += KEY_BBUTTON;
	if (cnt_temp & key_array[BUTTON_SEL]) cnt += KEY_SELECT;
	if (cnt_temp & key_array[BUTTON_STA]) cnt += KEY_START;
	if (cnt_temp & key_array[CURSOR_R]) cnt += KEY_RIGHT;
	if (cnt_temp & key_array[CURSOR_L]) cnt += KEY_LEFT;
	if (cnt_temp & key_array[CURSOR_U]) cnt += KEY_UP;
	if (cnt_temp & key_array[CURSOR_D]) cnt += KEY_DOWN;
	if (cnt_temp & key_array[BUTTON_R]) cnt += KEY_RBUTTON;
	if (cnt_temp & key_array[BUTTON_L]) cnt += KEY_LBUTTON;
	cnt = ~cnt;

	key.trg = (key.trg ^ cnt) & ~key.cnt;
	key.off = key.off ^ (~cnt & key.cnt);
	key.old = key.cnt;
	key.cnt = cnt;
	return;
}

//--------------------------------------------------------------
// L[z񏉊
void KeyArray_Init()
{
	key_array[BUTTON_A] = KEY_ABUTTON;
	key_array[BUTTON_B] = KEY_BBUTTON;
	key_array[BUTTON_SEL] = KEY_SELECT;
	key_array[BUTTON_STA] = KEY_START;
	key_array[CURSOR_R] = KEY_RIGHT;
	key_array[CURSOR_L] = KEY_LEFT;
	key_array[CURSOR_U] = KEY_UP;
	key_array[CURSOR_D] = KEY_DOWN;
	key_array[BUTTON_L] = KEY_LBUTTON;
	key_array[BUTTON_R] = KEY_RBUTTON;
	return;
}

//--------------------------------------------------------------
// L[zύX
void KeyArray_Change(u16 b1, u16 b2)
{
	if (b1 > 10) return;

	key_array[b1] = b2;
	return;
}
