//==================================================================
// gba_types.h
//==================================================================
#ifndef GBA_TYPES_H
#define GBA_TYPES_H

//--------------------------------------------------------------
// typedef
//--------------------------------------------------------------
typedef unsigned char  u8;
typedef unsigned short u16;
typedef unsigned long  u32;
typedef unsigned long long int u64;
typedef signed char  s8;
typedef signed short s16;
typedef signed long  s32;
typedef signed long long int s64;
typedef volatile unsigned char  vu8;
typedef volatile unsigned short vu16;
typedef volatile unsigned long  vu32;
typedef volatile unsigned long long int vu64;
typedef volatile signed char  vs8;
typedef volatile signed short vs16;
typedef volatile signed long  vs32;
typedef volatile signed long long int vs64;
typedef unsigned char  BYTE;
typedef unsigned short HWORD;
typedef unsigned long  WORD;

typedef	signed long long int	FIX32;
typedef	signed long	int			FIX16;
typedef	signed short int		FIX8;

#endif // GBA_TYPES_H
