#ifndef BIOSCALL_H
#include <gba.h>
#ifdef __cplusplus
extern "C" {
#endif

/* bios_divmod() ***********************
   Convert n/d to a mixed fraction q+r/d
   Returns Q.
*/
CODE_IN_IWRAM int bios_divmod (int num, int den, int *rem);
int Div(int num, int den);
int DivArm(int den, int num);

#ifdef __cplusplus
}
#endif
#endif
