#ifndef DISP_H
#define DISP_H

enum {
	CUR_TRK_0,
	CUR_TRK_1,
	CUR_TRK_2,
	CUR_TRK_3,
	CUR_TRK_4,
	CUR_TRK_5,
	CUR_TRK_6,
	CUR_TRK_7,
	CUR_TRK_8,
	CUR_TRK_9,
	CUR_TRK_A,
	CUR_TRK_B,
	CUR_TRK_C,
	CUR_TRK_D,
	CUR_TRK_E,
	CUR_TRK_F,

	CUR_VOL,
	CUR_KEY,
	CUR_BPM,

	CUR_BACK,
	CUR_PLAY,
	CUR_STOP,

	CUR_NONE,
};

extern vu16 *objpal;
extern vu16 *bgpal;
extern vu16 *tiles;
extern vu16 *map0;
extern vu16 *map1;
extern vu16 *map2;
extern vu16 *map3;


void DispInit();
void TrackDispUpdate();

void PrintTime(u32 count);
void PrintCpu(u32 num);
void PrintRate(u32 num);
void PrintCursor(u8 num, u8 pal);
void PrintStr(u16 *map, const char* chr, u8 x, u8 y, u8 pal);
void PrintDigit0(u16 *map, const s32 num, u8 digit, s16 x, s16 y, u8 pal);
void PrintDigit0I(u16 *map, const s32 num, u8 digit, s16 x, s16 y, u8 pal);
void PrintDigit(u16 *map, const s32 num, u8 digit, s16 x, s16 y, u8 pal);
void PrintHex(u16 *map, const u32 num, u8 digit, s16 x, s16 y, u8 pal);
#endif
