#ifndef _ISR_ARM_H
#define _ISR_ARM_H
#include <gba.h>
#ifdef __cplusplus
extern "C" {
#endif
CODE_IN_IWRAM void IRQ_Handler();
CODE_IN_IWRAM void IRQ_RegistFunc( u32, u32* );
CODE_IN_IWRAM void IRQ_UnRegistFunc( u32 );

#define Int_VBLANK	BIT0
#define Int_HBLANK	BIT1
#define Int_VCOUNT	BIT2
#define Int_TIMER0	BIT3
#define Int_TIMER1	BIT4
#define Int_TIMER2	BIT5
#define Int_TIMER3	BIT6
#define Int_SERIAL	BIT7
#define Int_DMA0	BIT8
#define Int_DMA1	BIT9
#define Int_DMA2	BIT10
#define Int_DMA3	BIT11
#define Int_JOY		BIT12
#define Int_CART	BIT13

#ifdef __cplusplus
}
#endif
#endif
