#ifndef DMA_CHAIN_H
#define DMA_CHAIN_H
#include <gba.h>
#ifdef __cplusplus
extern "C" {
#endif

#define MAX_DMA_CHAINS	128

// DMA]`FC
typedef struct {
	u32 *src;
	u32 *dst;
	u16 size;
} DMA_CHAIN;

CODE_IN_IWRAM void DMAChain_Enqueue(u32* src, u32* dst, u16 size);
CODE_IN_IWRAM void DMAChain_Transfer();

#ifdef __cplusplus
}
#endif
#endif
