#ifndef NMID_DEFS_H
#define NMID_DEFS_H

// System Message
#define NMID_SYS_WAIT		0x00
#define NMID_SYS_BPM		0x01
#define NMID_SYS_ENDDATA	0xff

enum {
	NMID_TRK_PLAY = 0,
	NMID_TRK_MUTE = 1,
};

enum {
	NMID_TRK_POLY = 0,
	NMID_TRK_MONO = 1,
};
//#define NMID_TRK_POLY		0
//#define NMID_TRK_MONO		1

// Status Message
#define MES_NOTE_OFF			0x80 // Note Off
#define MES_NOTE_ON				0x90 // Note On
#define MES_POLY_PRESSURE		0xA0 // Polyphonic Key Pressure
#define MES_CONTROL_CHANGE		0xB0 // Control Change
#define MES_PROGRAM_CHANGE		0xC0 // Program Change
#define MES_CHANNEL_PRESSURE	0xD0 // Channel Pressure
#define MES_PITCHBEND_CHANGE	0xE0 // PitchBend Change
#define MES_SYSTEM_MESSAGE		0xf0 // System Message

// Controle Change Message
#define CC_MODULATION			0x01 // Modulation
#define CC_PORTAMENT_TIME		0x05 // Portament Time
#define CC_VOLUME				0x07 // volume
#define CC_PANPOT				0x0a // panpot
#define CC_VOICEMODE			0x36 // Voice Mode (0-pcm 1-gb1 2-gb2 3-gb3 4-noise)
#define CC_VOICENUM				0x37 // Max Voice Nums
#define CC_LOOPPOINT			0x38 // Loop Point
#define CC_MODSPEED				0x39 // Modulation Speed
#define CC_MODPOWER				0x3a // Modulation Power

#define CC_HOLD					0x40 // Hold (Not Implemented)
#define CC_PORTAMENT			0x41 // Portament
#define CC_OMNI_OFF				0x7c // Omni Off
#define CC_OMNI_ON				0x7d // Omni On
#define CC_MONO_ON				0x7e // Mono On
#define CC_POLY_ON				0x7f // Poly On

#endif
