#include <gba.h>
#include <gamemath.h>
#include <sprite.h>
#include "dsp_spr.h"
#include "_ChrTable.h"

const SPR_PAT ChrTable[MAX_CHR_NUMBER] = {
//	Keyboard Lights
	[0x0000] = { (u16 *)&dsp_spr_chr[OBJ_SHORT_SIZE_32x8 *  0], OBJ_SIZE_32x8, 2 }, // $0000 C
	[0x0001] = { (u16 *)&dsp_spr_chr[OBJ_SHORT_SIZE_32x8 *  1], OBJ_SIZE_32x8, 2 }, // $0001 C+
	[0x0002] = { (u16 *)&dsp_spr_chr[OBJ_SHORT_SIZE_32x8 *  2], OBJ_SIZE_32x8, 2 }, // $0002 D
	[0x0003] = { (u16 *)&dsp_spr_chr[OBJ_SHORT_SIZE_32x8 *  3], OBJ_SIZE_32x8, 2 }, // $0003 D+
	[0x0004] = { (u16 *)&dsp_spr_chr[OBJ_SHORT_SIZE_32x8 *  4], OBJ_SIZE_32x8, 2 }, // $0004 E
	[0x0005] = { (u16 *)&dsp_spr_chr[OBJ_SHORT_SIZE_32x8 *  5], OBJ_SIZE_32x8, 2 }, // $0004 F
	[0x0006] = { (u16 *)&dsp_spr_chr[OBJ_SHORT_SIZE_32x8 *  6], OBJ_SIZE_32x8, 2 }, // $0004 F+
	[0x0007] = { (u16 *)&dsp_spr_chr[OBJ_SHORT_SIZE_32x8 *  7], OBJ_SIZE_32x8, 2 }, // $0004 G
	[0x0008] = { (u16 *)&dsp_spr_chr[OBJ_SHORT_SIZE_32x8 *  8], OBJ_SIZE_32x8, 2 }, // $0004 G+
	[0x0009] = { (u16 *)&dsp_spr_chr[OBJ_SHORT_SIZE_32x8 *  9], OBJ_SIZE_32x8, 2 }, // $0004 A
	[0x000a] = { (u16 *)&dsp_spr_chr[OBJ_SHORT_SIZE_32x8 * 10], OBJ_SIZE_32x8, 2 }, // $0004 A+
	[0x000b] = { (u16 *)&dsp_spr_chr[OBJ_SHORT_SIZE_32x8 * 11], OBJ_SIZE_32x8, 2 }, // $0004 B
};
